Bug 234486 - pygrub tries to read menu.lst before grub.conf, tries to start non-existent kernel
pygrub tries to read menu.lst before grub.conf, tries to start non-existent k...
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: xen (Show other bugs)
5.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Daniel Berrange
: EasyFix, Patch, Reopened
Depends On:
Blocks: 449772
  Show dependency treegraph
 
Reported: 2007-03-29 12:23 EDT by Nils Philippsen
Modified: 2009-01-20 16:13 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 16:13:21 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
patch to let pygrub check for grub.conf before checking for menu.lst (543 bytes, patch)
2007-03-29 12:23 EDT, Nils Philippsen
no flags Details | Diff
Actual patch posted for inclusion (769 bytes, patch)
2008-07-10 07:20 EDT, Daniel Berrange
no flags Details | Diff

  None (edit)
Description Nils Philippsen 2007-03-29 12:23:32 EDT
Description of problem:

After updating a virtual machine I couldn't restart it with "xm create", it
searched for a (now non-existent) old version of the kernel and initrd. I found
that something or someone wrote a menu.lst that wasn't a symlink to grub.conf,
i.e. its contents didn't change when the kernel was updated. pygrub read that
menu.lst instead of the (correct) grub.conf and failed to start the guest.

I've attached a patch to pygrub that lets it check grub.conf before menu.lst
which should fix this problem.

Version-Release number of selected component (if applicable):

xen-3.0.3-25.0.3.el5
Comment 1 Nils Philippsen 2007-03-29 12:23:32 EDT
Created attachment 151210 [details]
patch to let pygrub check for grub.conf before checking for menu.lst
Comment 2 Jeremy Katz 2007-03-29 13:45:25 EDT
And then you could have the problem the other way.  This is the unfortunate
problem with the difference in grub config naming between distros.
Comment 3 Nils Philippsen 2007-03-30 04:00:55 EDT
If we use grub.conf in one place and prefer menu.lst in another, we're not
consistent with ourselves. Don't you think pygrub should (if in doubt) use what
we use elsewhere? The way it is, we support other distros better than we support
RHEL as a guest, which is more than unfortunate. AFAIK other distros don't have
both a grub.conf and a menu.lst, so the patch aboive shouldn't cause problems
with them.

The least we should do (if we are going out of our way to support other distros
better than our own) is warn people about the circumstance that there are both a
grub.conf and a menu.lst file and which one we used.
Comment 4 Daniel Berrange 2008-07-09 07:21:52 EDT
The real 'grub' package in RHEL-5 has a patch grub-0.93-configfile.patch which
removes its use of menu.lst in favour of grub.conf. 

pygrub needs to behave in the same way, and not look at menu.lst so we are at
least consistent within RHEL-5.

Comment 5 RHEL Product and Program Management 2008-07-09 07:39:15 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 7 Daniel Berrange 2008-07-10 07:20:57 EDT
Created attachment 311468 [details]
Actual patch posted for inclusion
Comment 9 Daniel Berrange 2008-07-21 06:48:09 EDT
Built into xen-3.0.3-67.el5
Comment 12 errata-xmlrpc 2009-01-20 16:13:21 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-0118.html

Note You need to log in before you can comment on or make changes to this bug.